//#pragma once
#include <windows.h>
#include <d3dx9math.h>

class DIrunner;
class WinClass;
class App;
class DSrunner;
class DSsound;
class D3Drunner;
class Renderable;
class LitCube;
class nGon;
class Planet;
class PlanetList;
class nSphere;
class nCube;
class Land;
class Player;
class KeyController;
class Controller;
class ShootCube;
class LightBall;
class DPlayRunner;
class nTrail;

#ifndef FPOINTS
#define FPOINTS

struct fPOINT
{
	float x,y,z;
};

#endif


#ifndef CUSTVERT
#define CUSTVERT

//#define USING_COLOR
#define USING_NORMAL

struct CUSTOMVERTEX
{
	D3DXVECTOR3 position;
#ifdef USING_NORMAL
	D3DXVECTOR3 normal;
#endif
#ifdef USING_COLOR
	DWORD color;
#endif
#ifdef USING_TUTV
	float tu,tv; // texture coordinates
#endif
};

struct TRIANGLE
{
	CUSTOMVERTEX v[3];
};

#endif