#include "Classes.h"
#include <string.h>




class Planet
{
private:
	int mass;
	float xPos;
	float yPos;
	float zPos;
	float xforce;
	float yforce;
	float zforce;
	float modXforce;
	float modYforce;
	float modZforce;

	float xVel;
	float yVel;
	float zVel;
	float gm;

	float totalx;
	float totaly;
	float totalz;
	bool* forceApplied;

	int nPlanets;

	

public:
	Planet(int mass, float xPos,float yPos,float zPos,float xVel,float yVel,float zVel,int nPlanets);
	~Planet();
	void setForceApplied(int whichSource,float x,float y,float z);
	int getMass();
	void Run(PlanetList* planetList,int whichPlanet);
	void Move();
	float getX();
	float getY();
	float getZ();

	float getdX();
	float getdY();
	float getdZ();

	float gettX();
	float gettY(); // gets the total x,y, or z movement in last planetList cycel
	float gettZ();
	void Clear();

};

class PlanetList
{
private:
	int maxSize;
	int numPlanets;
	Planet** planets;
	
	void PlanetList::makePlanets(int nPlanets,int starMass,float distMin,float distMax,float massMax,float massMin);

public:
	PlanetList(int numPlanets);
	PlanetList(char* filename);
	~PlanetList();

	Planet* getPlanet(int index);
	int getNumPlanets();	
	int getMaxMass();
	void applyForce(int index,float x,float y,float z);
	void Run();
};

