#include <d3dx9math.h>
#include "Classes.h"


class Player
{
private:
	float x;
	float y; // position
	float z;
	float lookX; // angles of looking
	float lookY;
	float lookZ;
	Controller* myController;
	

	
public:
	Player(float,float,float,float,float,float);
	Player(float,float,float);

	void move(float,float,float); // makes the player move in absolute directions
	void look(float,float,float); // makes the player look at stuff
	void moveRel(float,float,float); // moves the player relative to their view

	float getLX();
	float getLY();
	float getLZ();

	float getX();
	float getY();
	float getZ();

	void Run();

	void setController(Controller* what);

	D3DXMATRIXA16 getLookPt();
};