#include "WinClass.h"
#include "App.h"
#include <windows.h>

void writeCrap(const char * what);

bool done;

HWND WinClass::getHandle()
{
	return myHandle;
}
WinClass::WinClass(char const * caption,HINSTANCE hInt,int cmdShow)
{
	//writeCrap("Inside constructor for winClass");
	char const * className = "myWindowClass";
	int err;
	err = createRegister(className,hInt);
	//writeCrap("registering the class complete");
	err = createHandle(className,caption,hInt);
	//writeCrap("creating the handle complete");
	if(err != 0)
	{
		MessageBox(NULL,"WinClass::WinClass() had an error after creating the handle","Error",0);
	}	
	ShowWindow(myHandle,cmdShow);
	this->myApp = NULL;
	
}
WinClass::WinClass(char const * className,HWND hWnd)
{
	this->myHandle = hWnd;	
	this->myApp = NULL;
}

void WinClass::AddApp(App* what)
{
	if(this->myApp != NULL)
	{
		delete myApp;
	}
	this->myApp = what;
}
int WinClass::msgLoop()
{

	if(this->myApp == NULL)
	{	writeCrap("You cannot start the Window without giving it an application");
		return -1;
	}
	MSG msg;	
	unsigned long Counter =0;
	done = false;
	myApp->Init(this);

	while(!done )
	{
		if(PeekMessage(&msg,0,0,0,PM_REMOVE))
		{
		  TranslateMessage(&msg);
		  DispatchMessage(&msg);
		}
		else
		{
			Counter++;
		    myApp->OneStep(&done);
		}
	}
	myApp->Close();
	return 0;
}
int WinClass::createHandle(char const * className,char const * caption,HINSTANCE hInt)
{
	
	myHandle = ::CreateWindow (
        className,              // name of a registered window class
        caption,                // window caption
        WS_OVERLAPPEDWINDOW,    // window style
        CW_USEDEFAULT,          // x position
        CW_USEDEFAULT,          // y position
        CW_USEDEFAULT,          // witdh
        CW_USEDEFAULT,          // height
        0,                      // handle to parent window
        0,                      // handle to menu
        hInt,              // application instance
        0 );	

	if(myHandle == NULL)
	{
		MessageBox(NULL,"Could not create window","Error",0);
		return -1;
	}
	return 0;
}
HINSTANCE WinClass::getInst()
{
	return myInst;
}
int WinClass::createRegister(char const * className,HINSTANCE hInt)
{	

	myClass.hCursor        = NULL; 
	myClass.hIcon          = 0; 
	myClass.lpszMenuName   = 0; 
	myClass.lpszClassName  = className; 
	myClass.hbrBackground  = (HBRUSH) (COLOR_WINDOW + 1); 
	myClass.hInstance      = hInt; 
	myClass.style          = CS_VREDRAW  | CS_HREDRAW | CS_SAVEBITS | CS_DBLCLKS; 
	myClass.lpfnWndProc    = winProc; 
	myClass.cbWndExtra     = 0; 
	myClass.cbClsExtra     = 0;

	//myClass.style = 0;
    //myClass.lpfnWndProc = winProc;  // Window Procedure: mandatory
    //myClass.cbClsExtra = 0;
    //myClass.cbWndExtra = 0;
    //myClass.hInstance = hInt;           // owner of the class: mandatory
    //myClass.hIcon = 0;
    //myClass.hCursor = ::LoadCursor (0, IDC_ARROW); // optional
    //myClass.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1); // optional
    //myClass.lpszMenuName = 0;
    //myClass.lpszClassName = className;   // mandatory
	RegisterClass(&myClass);
	myInst = hInt;
	return 0;
}
LRESULT CALLBACK winProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	
	switch (message)
    {
		// In this simple program, this is the only message we are processing
        case WM_DESTROY:
            ::PostQuitMessage (0);
			done =true;
            return 0; // return zero when processed

    }
	// All the unprocessed messages go there, to be dealt in some default way
    return ::DefWindowProc (hwnd, message, wParam, lParam );
}