#include "Classes.h"
#include "nGon.h"

struct VecPair
{
	MyVector vecs[2];	
};


class nTrail : public nGon
{
private:
	VecPair* vecHead;	// array of vector pairs, which define our squares
	int curPos;			// next element of vecHead that will get popped to the front of the trail
	float width;		// width of our trail
	int numSeg;			// number of segments


	void moveVertices(int which,int lastPos);	// moves the nGon vertices that need to get moved to match a certain vertex

public:
	nTrail(D3Drunner*,int,float x,float y,float z,float width);
	~nTrail();
	void Transform(float x,float y,float z);
};