#include "classes.h"
#include "nGon.h"
#include <d3d9.h>
//#include "Lightball.h"
#ifndef NCUBE_LOAD
#define NCUBE_LOAD

class nCube : public nGon
{
private:

public:
	nCube(D3Drunner* runner,float width,float x,float y,float z);
};

class ShootCube : public nCube
{
private:
	float xVel;
	float yVel;
	float zVel;
	bool shot;
	Player* myGuy;
	

public:
	ShootCube(D3Drunner* runner,float width,Player* whoShoot);
	void Render(LPDIRECT3DDEVICE9,App*,int);
	void Shoot();
};

class LitCube : public nCube
{
private:
	LightBall* myLight;
	LPDIRECT3DTEXTURE9 tex;
	nTrail* myTrail;


	int counter;
	MyVector movement;
public:
	LitCube(D3Drunner* runner,float width,float x,float y,float z);
	LitCube(D3Drunner* runner,float width,float x,float y,float z,float range,float lr,float lg, float lb);
	~LitCube();
	void Render(LPDIRECT3DDEVICE9,App*,int);
	void Transform(float,float,float);
};

#endif